(define-module (ui mkve adopt ajax)
               :use-module (alterator ajax)
               :use-module (alterator woo)
               :use-module (alterator str)

               :export (init))

(define (adopt-openvz)
  (woo-write "/mkve-adopt"
             'adopt "yes"
             'language (form-value "language")
             'machine_name (form-value "name")
             'args (form-value "openvz_ctid")
             'hypervisor (form-value "hypervisor")
             )
  )

(define (check-input-openvz)
  (and (string-null? (form-value "name"))
       (form-error (_ "Name is empty"))))

(define (adopt)
  (check-input-openvz)
  (if (catch/message adopt-openvz)
    (form-replace
      (string-append
        "/mkve/" (form-value "hypervisor") "?machine=" (form-value "name"))))
  )

(define (setup-hypervisor)
  (let* ((data (woo-list "/mkve-adopt/list_hypervisors"))
         (hypervisor (woo-get-option (car data) 'name)))
    (form-update-enum "hypervisor" data)
    (form-update-value "hypervisor" hypervisor)))

(define (there-are-no-openvz-machines x)
  (form-update-visibility "none" x)
  (form-update-visibility "adopt" (not x))
  (form-update-visibility "name" (not x))
  (form-update-visibility "openvz_ctid" (not x)))

(define (setup-openvz)
  (let* ((data (woo-list "/mkve-adopt/list_openvz_ctids"))
         (mach (or (null? data) (woo-get-option (car data) 'name))))
    (there-are-no-openvz-machines (null? data))
    (or (null? data) (begin (form-update-enum "openvz_ctid" data)
                    (form-update-value "openvz_ctid" mach)))))

(define (setup-bindings)
  (form-bind "adopt" "click" adopt))

(define (init)
  (setup-hypervisor)
  (setup-openvz)
  (setup-bindings))
