(define-module (ui mkve openvz ajax)
               :use-module (alterator ajax)
               :use-module (alterator woo)

               :export (init))

(define (say message) (format #t (string-append message "~%")))

(define (update-header)
  (form-update-value "machine" (woo-get-option (woo-read-first "/mkve-openvz/machine") 'machine)))

(define (do-add-ip)
  (woo-write "/mkve-openvz"
             'machine (form-value "machine")
             'language (form-value "language")
             'add_ip "yes"
             'newip (form-value "newip")))

(define (do-del-ip)
  (woo-write "/mkve-openvz"
             'machine (form-value "machine")
             'language (form-value "language")
             'del_ip "yes"
             'del_ip_list (form-value "ip_address")))

(define (update-ip-list)
    (let
      ((ip_addresses (woo-list "/mkve-openvz/list_ip_address")))
      (form-update-enum "ip_address" ip_addresses)))

(define (update-ifaces)
  (form-update-enum "ifaces_table" (woo-list "/mkve-openvz/list_interfaces")))

(define (update-links)
  (form-update-enum "alterator_ip_table" (woo-list "/mkve-openvz/list_alterator_ip")))

(define (add-ip)
  (catch/message do-add-ip)
  (update-ip-list)
  (update-links))

(define (del-ip)
  (catch/message do-del-ip)
  (update-ip-list)
  (update-links))

(define (do-set-password)
  (woo-write "/mkve-openvz"
             'language (form-value "language")
             'password (form-value "passwd_1"))
  )

(define (set-password)
  (form-update-visibility "passwd_message" #f)
  (if (string=? (form-value "passwd_1") (form-value "passwd_2"))
      (if (not (string=? "" (form-value "passwd_2")))
        (form-update-visibility "passwd_message" (catch/message do-set-password)))
      (form-error (_ "Passwords mismatch"))))

(define (go-main) (form-replace "/mkve"))

(define (init)
  (update-header)
  (update-ip-list)
  (update-ifaces)
  (update-links)

  (form-bind "set_password" "click" set-password)
  (form-bind "add_ip" "click" add-ip)
  (form-bind "del_ip" "click" del-ip)

  (form-bind "gomain" "click" go-main)
  )
