(define-module (ui mkve openvz quota ajax)
               :use-module (alterator ajax)
               :use-module (alterator woo)

               :export (init))

(define (name) (woo-get-option (woo-read-first "/mkve-openvz/machine") 'machine))

(define (init-header)
  (form-update-value "header"
                     (string-append (_ "Disk quotas for machine") " " (name)))
  )


(define (show-hide-quota-div)
  (form-update-visibility "quota_div" (form-value "quota_checkbox")))

(define (reset)
  (let ((data (woo-read-first "/mkve-openvz/quota")))
    (form-update-value "quota_checkbox" (woo-get-option data 'quota_checkbox))
    (form-update-value "quota_expire" (woo-get-option data 'quota_expire)))
  (form-update-enum "quota_table" (woo-list "/mkve-openvz/list_quotas")))

(define (do-submit)
  (woo-write "/mkve-openvz/quota"
                  'language (form-value "language")
                  'softlimit (form-value "softlimit")
                  'hardlimit (form-value "hardlimit")
                  'quota_checkbox (form-value "quota_checkbox")
                  'quota_expire (form-value "quota_expire")))
(define (submit) (catch/message do-submit))

(define (back) (form-replace "/mkve/openvz"))

(define (init)
  (init-header)
  (reset)
  (form-bind "quota_checkbox" "change" show-hide-quota-div)

  (form-bind "submit" "click" submit)
  (form-bind "reset" "click" reset)
  (form-bind "back" "click" back)
  )
