(define-module (ui mkve pack ajax)
               :use-module (alterator ajax)
               :use-module (alterator woo)

               :export (init))

(define (update-lzma hypervisor)
  (form-update-visibility "lzma" (string=? hypervisor "kvm"))
  )

(define (update-output name)
  (if (string=? name "")
    (form-update-value "output" "")
    (form-update-value "output" (string-append "/srv/share/bundles/" name ".bun")))
  )

(define (setup-name-related)
    (update-lzma
      (woo-get-option
        (woo-read-first "/mkve"
                        'name (form-value "name")
                        'language (form-value "language"))
        'hypervisor))
    (update-output (form-value "name"))
    )

(define (do-pack)
  (woo-write "/mkve/pack"
             'apply "yes"
             'language (form-value "language")
             'name (form-value "name")
             'lzma (and (form-value "lzma") "")
             'output (form-value "output")))

(define (pack)
  (and (catch/message do-pack) (form-replace "/mkve")))

(define (setup-bindings)
  (form-bind "name" "change" setup-name-related)
  (form-bind "pack" "click" pack)
  )

(define (setup-form data)
  (form-update-enum "name" data)
  (form-update-value "name" (woo-get-option (car data) 'name))

  (setup-name-related)
  (setup-bindings)
  )

(define (no-machines)
  (form-update-visibility "all" #f)
  (form-warning (_ "There are no machines to pack"))
  (form-replace "/mkve")
  )

(define (init)
  (let ((data (woo-list "/mkve/list_machines")))
    (or (and (null? data) (no-machines)) (setup-form data))))
